use clap::{Args, ValueEnum};

#[derive(Args)]
pub struct Arguments {
    #[clap(value_enum, value_parser)]
    pub color_depth: ColorType,

    #[clap(value_enum, value_parser, default_value_t=ClutAlignment::None)]
    pub clut_align: ClutAlignment,

    #[clap(long=SemiTransparent::NAME, default_value_t=false)]
    pub semi_transparent: SemiTransparent::Type,

    #[clap(long=TransparentPalette::NAME, default_value_t=false)]
    pub transparent_palette: TransparentPalette::Type
}

#[derive(Copy, Clone, PartialEq, Eq, PartialOrd, Ord, ValueEnum)]
pub enum ColorType{
    Clut4,
    Clut8,
    Full16,
}

#[derive(Copy, Clone, PartialEq, Eq, PartialOrd, Ord, ValueEnum)]
pub enum ClutAlignment {
    None,
    Linear,
    Block
}

#[allow(non_snake_case)]
pub mod SemiTransparent {
    pub type               Type = bool;
    pub const NAME:&'static str = "semi-trans";
}

#[allow(non_snake_case)]
pub mod TransparentPalette {
    pub type Type = bool;
    pub const NAME:&'static str = "";
}
